//---------------------------------------------------------------------------
//	sinku.dll wb_t@C
//	H쏊
//---------------------------------------------------------------------------
#ifndef sinkuH
#define sinkuH
//---------------------------------------------------------------------------
#include <tchar.h>
//---------------------------------------------------------------------------
#define	VA_MAX_STREAM_COUNT	10
#define	EX_MAX_STREAM_COUNT	5
#define	STR_MAX_LENGTH		512
#ifdef _UNICODE
	#define	FILENAME_MAX_LENGTH	256
#else
	#define	FILENAME_MAX_LENGTH	512
#endif

enum {
	//t@C`

	//G[n
	FILETYPE_ERROR = 0,

	FILETYPE_UNKNOWN,			//Ή̃t@C
	FILETYPE_OPENFAILED,		//t@C̃I[vɎs

	//G[nI
	FILETYPE_ERROR_END,

	//Đ\Ȍ`
	FILETYPE_MEDIA = 10,

	//fƉ`
	FILETYPE_VIDEO_AUDIO,
	FILETYPE_AVI,				//RIFF AVI
	FILETYPE_MPEG1,				//MPEG1
	FILETYPE_MPEG1VCD,			//MPEG1(VideoCD)
	FILETYPE_OGGMEDIA,			//Ogg Media
	FILETYPE_MPEG2,				//MPEG2
	FILETYPE_MPEG2_TS,			//MPEG2-TS
	FILETYPE_WMV,				//WindowsMedia Video
	FILETYPE_REALMEDIA,			//RealMedia
	FILETYPE_QUICKTIME,			//QuickTime
	FILETYPE_MPEG4,				//QuickTime(MPEG4)
	FILETYPE_RESERVED2,			//gp
	FILETYPE_RESERVED3,			//gp
	FILETYPE_RESERVED4,			//gp
	FILETYPE_MATROSKA,			//Matroska
	FILETYPE_FLASHVIDEO,		//FlashVideo

	//摜̌`(܂)
	FILETYPE_GRAPHIC = 50,
	FILETYPE_BMP,				//BMP
	FILETYPE_JPEG,				//JPEG/Exif
	FILETYPE_GIF,				//GIF

	//摜̌`I
	FILETYPE_GRAPHIC_END,

	//fƉ`I
	FILETYPE_VIDEO_AUDIO_END,

	//݂̂̌`
	FILETYPE_AUDIO = 100,
	FILETYPE_WAV,				//RIFF WAVE
	FILETYPE_MID,				//MIDI
	FILETYPE_RMI,				//RIFF MIDI
	FILETYPE_AU,				//Au
	FILETYPE_AIFF,				//AIFF
	FILETYPE_MP3,				//MP3(MPEG1`2.5 LayerI`III)
	FILETYPE_CDA,				//RIFF CDDA
	FILETYPE_RMP3,				//RIFF MP3
	FILETYPE_OGGVORBIS,			//Ogg Vorbis
	FILETYPE_OGGSPEEX,			//Ogg Speex
	FILETYPE_OGGFLAC,			//Ogg Flac
	FILETYPE_WMA,				//WindowsMedia Audio
	FILETYPE_AC3,				//Dolby AC-3
	FILETYPE_MONKEY,			//Monkey's Audio
	FILETYPE_MUSEPACK,			//MusePack
	FILETYPE_FLAC,				//Flac
	FILETYPE_AAC,				//AAC(MPEG2/MPEG4)
	FILETYPE_REALAUDIO,			//RealMediaȑŐRealAudio
	FILETYPE_TTA,				//The True Audio
	FILETYPE_DTS14LE,			//DTS
	FILETYPE_DTS14BE,
	FILETYPE_DTS16LE,
	FILETYPE_DTS16BE,
	FILETYPE_WAVPACK,			//WavPack
	FILETYPE_OPTIMFROG,			//OptimFROG
	FILETYPE_VQ,				//TwinVQ
	FILETYPE_SWA,				//Shockwave Audio
	FILETYPE_PUREVOICE,			//QUALCOMM PureVoice
	FILETYPE_S98,				//S98
	FILETYPE_DSF,				//DSD Stream File
	FILETYPE_DSDIFF,			//Direct Stream Digital Interchange File Format
	FILETYPE_WSD,				//Wideband Single-bit Data
	FILETYPE_MSF,				//PS3 MSF

	//݂̂̌`I
	FILETYPE_AUDIO_END,

	//Đ\Ȍ`I
	FILETYPE_MEDIA_END,

	//ȉeXgp(F͂ĂȏtĂȂ)̌`
	FILETYPE_TEST = 200,
	FILETYPE_RESERVED5,			//gp

	//eXgp̌`I
	FILETYPE_TEST_END,

	//vCXg
	FILETYPE_PLAYLIST = 300,
	PLAYLIST_SHDKL,
	PLAYLIST_PLS,
	PLAYLIST_LST,
	PLAYLIST_ZPL,
	PLAYLIST_BSL,
	PLAYLIST_M3U,
	PLAYLIST_M3U8,

	//vCXgI
	FILETYPE_PLAYLIST_END,
};

typedef struct {
	TCHAR				name[FILENAME_MAX_LENGTH];					//IN     : t@C
	int					type;										//IN/OUT : t@C
	char				container[32];								//OUT    : Rei(ꍇ̂)
	char				error[STR_MAX_LENGTH];						//OUT    : G[(ꍇ̂)
	char				video[VA_MAX_STREAM_COUNT][STR_MAX_LENGTH];	//OUT    : f̏ڍ
	int					video_count;								//OUT    : f̏ڍׂ̐
	char				audio[VA_MAX_STREAM_COUNT][STR_MAX_LENGTH];	//OUT    : ̏ڍ
	int					audio_count;								//OUT    : ̏ڍׂ̐
	char				extra[EX_MAX_STREAM_COUNT][STR_MAX_LENGTH];	//OUT    : t
	int					extra_count;								//OUT    : t̐
	double				playtime;									//OUT    : Đ(b)
	unsigned __int64	size;										//OUT    : t@CTCY
} FILE_INFO;

typedef struct
{
	HINSTANCE	hDLL;
	int		version;

	int		(__stdcall *GetDllVersion )( void );
	void	(__stdcall *SetPath )( TCHAR *path );
	void	(__stdcall *GetFileFormat )( FILE_INFO *pFILE_INFO );
	void	(__stdcall *GetFileInfo )( FILE_INFO *pFILE_INFO );
	void	(__stdcall *GetFileInfoAuto )( FILE_INFO *pFILE_INFO );
	void	(__stdcall *ConvertOne )( FILE_INFO *pFILE_INFO, char *str );
	void	(__stdcall *ConvertFull )( FILE_INFO *pFILE_INFO, char *str );
	int		(__stdcall *ConvertOneLen )( FILE_INFO *pFILE_INFO );
	int		(__stdcall *ConvertFullLen )( FILE_INFO *pFILE_INFO );
	int		(__stdcall *Unicode )( void );
} SinkuFunc;

//---------------------------------------------------------------------------
#endif
